/**
 *  Copyright (C) (2010-2012) Vadim Biktashev, Alexander Karpov, 
 *                            Irina Biktasheva, Ross McFarlane;
 *  Copyright (C) 2012 Sanjay Kharche
 *
 *  This file is part of Beatbox.
 *
 *   Beatbox is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Beatbox is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Beatbox.  If not, see <http://www.gnu.org/licenses/>.
 */


/* Produce an XWD file from current X screen */
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "system.h"
#include "beatbox.h"
#include "bikt.h"
#include "bgi.h"
#include "device.h"
#include "state.h"
#include "qpp.h"
#include "sequence.h"
#include "byte.h"

#define DEBUG if (0) MESSAGE

typedef struct {
  sequence file;
  char fmt[16];
} STR;

RUN_HEAD(screen_dump)
  DEVICE_VAR(sequence,file)	   
  DEVICE_ARRAY(char,fmt)	   
                           DEBUG("file %s is in the sequence\n",file->name);
  fclose(file->f);	   DEBUG("file %s closed\n",file->name);
  file->f=NULL;		   DEBUG("file handle nulled\n",file->name);
  dump_window(file->name,fmt); DEBUG("dump_window done to %s\n",file->name);
  nextq(file); 		   DEBUG("nextq file is %s\n",file->name);
RUN_TAIL(screen_dump)

DESTROY_HEAD(screen_dump)
S->fmt[0]='\0';
DESTROY_TAIL(screen_dump)

CREATE_HEAD(screen_dump) {
  ACCEPTQ(file,"wb",NULL);
  ACCEPTS(fmt,"jpeg");
  if (stricmp(S->fmt,"jpg") && stricmp(S->fmt,"jpeg") && stricmp(S->fmt,"gif") && stricmp(S->fmt,"ppm")) 
    EXPECTED_ERROR("unknown format '%s'\n",S->fmt);
} CREATE_TAIL(screen_dump,0)

