/**
 *  Copyright (C) (2010-2012) Vadim Biktashev, Alexander Karpov, 
 *                            Irina Biktasheva, Ross McFarlane;
 *  Copyright (C) 2012 Sanjay Kharche
 *
 *  This file is part of Beatbox.
 *
 *   Beatbox is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Beatbox is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Beatbox.  If not, see <http://www.gnu.org/licenses/>.
 */


typedef struct {
  char mask[MAXPATH];
  char name[MAXPATH];
#if MPI
  MPI_File f;
  int mpiMode;
  MPI_Comm comm;
#else
  FILE *f;
#endif
  char mode[8];
  int n;
  int mute;
} sequence;

int nextq(sequence *q);

#if MPI
/* MPI version includes runHere so that a new communicator can be created. */
#define ACCEPTQ(b,c,d)   if (!acceptq(#b"=",c,d,dev->s.runHere,&(S->b),w)) return(0)
int acceptq (const char *name,const char *mode,const char *deflt,int runHere,sequence *q, char *w);
#else
#define ACCEPTQ(b,c,d)   if (!acceptq(#b"=",c,d,&(S->b),w)) return(0)
int acceptq (const char *name,const char *mode,const char *deflt,sequence *q, char *w);
#endif

