/**
 *  Copyright (C) (2010-2012) Vadim Biktashev, Alexander Karpov, 
 *                            Irina Biktasheva, Ross McFarlane;
 *  Copyright (C) 2012 Sanjay Kharche
 *
 *  This file is part of Beatbox.
 *
 *   Beatbox is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Beatbox is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Beatbox.  If not, see <http://www.gnu.org/licenses/>.
 */


_(   g_CaL , 0.0000398 , 1 )   // litre_per_farad_second (in L_type_Ca_current)
_(   g_bca , 0.000592 , 1 )   // nanoS_per_picoF (in calcium_background_current)
_(   Buf_c , 0.2 , 1 )   // millimolar (in calcium_dynamics)
_(   Buf_sr , 10.0 , 1 )   // millimolar (in calcium_dynamics)
_(   Buf_ss , 0.4 , 1 )   // millimolar (in calcium_dynamics)
_(   Ca_o , 2.0 , 1 )   // millimolar (in calcium_dynamics)
_(   EC , 1.5 , 1 )   // millimolar (in calcium_dynamics)
_(   K_buf_c , 0.001 , 1 )   // millimolar (in calcium_dynamics)
_(   K_buf_sr , 0.3 , 1 )   // millimolar (in calcium_dynamics)
_(   K_buf_ss , 0.00025 , 1 )   // millimolar (in calcium_dynamics)
_(   K_up , 0.00025 , 1 )   // millimolar (in calcium_dynamics)
_(   V_leak , 0.00036 , 1 )   // per_millisecond (in calcium_dynamics)
_(   V_rel , 0.102 , 1 )   // per_millisecond (in calcium_dynamics)
_(   V_sr , 0.001094 , 1 )   // micrometre3 (in calcium_dynamics)
_(   V_ss , 0.00005468 , 1 )   // micrometre3 (in calcium_dynamics)
_(   V_xfer , 0.0038 , 1 )   // per_millisecond (in calcium_dynamics)
_(   Vmax_up , 0.006375 , 1 )   // millimolar_per_millisecond (in calcium_dynamics)
_(   k1_prime , 0.15 , 1 )   // per_millimolar2_per_millisecond (in calcium_dynamics)
_(   k2_prime , 0.045 , 1 )   // per_millimolar_per_millisecond (in calcium_dynamics)
_(   k3 , 0.06 , 1 )   // per_millisecond (in calcium_dynamics)
_(   k4 , 0.005 , 1 )   // per_millisecond (in calcium_dynamics)
_(   max_sr , 2.5 , 1 )   // dimensionless (in calcium_dynamics)
_(   min_sr , 1.0 , 1 )   // dimensionless (in calcium_dynamics)
_(   K_pCa , 0.0005 , 1 )   // millimolar (in calcium_pump_current)
_(   g_pCa , 0.1238 , 1 )   // picoA_per_picoF (in calcium_pump_current)
_(   g_Na , 14.838 , 1 )   // nanoS_per_picoF (in fast_sodium_current)
_(   g_K1 , 5.405 , 1 )   // nanoS_per_picoF (in inward_rectifier_potassium_current)
_(   Cm , 0.185 , 1 )   // microF (in membrane)
_(   F , 96485.3415 , 1 )   // coulomb_per_millimole (in membrane)
_(   R , 8314.472 , 1 )   // joule_per_mole_kelvin (in membrane)
_(   T , 310.0 , 1 )   // kelvin (in membrane)
_(   V_c , 0.016404 , 1 )   // micrometre3 (in membrane)
_(   stim_amplitude , 52.0 , 1 )   // picoA_per_picoF (in membrane)
_(   stim_duration , 1.0 , 1 )   // millisecond (in membrane)
_(   stim_period , 1000.0 , 1 )   // millisecond (in membrane)
_(   stim_start , 10.0 , 1 )   // millisecond (in membrane)
_(   K_o , 5.4 , 1 )   // millimolar (in potassium_dynamics)
_(   g_pK , 0.0146 , 1 )   // nanoS_per_picoF (in potassium_pump_current)
_(   g_Kr , 0.153 , 1 )   // nanoS_per_picoF (in rapid_time_dependent_potassium_current)
_(   P_kna , 0.03 , 1 )   // dimensionless (in reversal_potentials)
_(   g_Ks , 0.392 , 1 )   // nanoS_per_picoF (in slow_time_dependent_potassium_current)
_(   g_bna , 0.00029 , 1 )   // nanoS_per_picoF (in sodium_background_current)
_(   K_NaCa , 1000.0 , 1 )   // picoA_per_picoF (in sodium_calcium_exchanger_current)
_(   K_sat , 0.1 , 1 )   // dimensionless (in sodium_calcium_exchanger_current)
_(   Km_Ca , 1.38 , 1 )   // millimolar (in sodium_calcium_exchanger_current)
_(   Km_Nai , 87.5 , 1 )   // millimolar (in sodium_calcium_exchanger_current)
_(   alpha , 2.5 , 1 )   // dimensionless (in sodium_calcium_exchanger_current)
_(   gamma , 0.35 , 1 )   // dimensionless (in sodium_calcium_exchanger_current)
_(   Na_o , 140.0 , 1 )   // millimolar (in sodium_dynamics)
_(   K_mNa , 40.0 , 1 )   // millimolar (in sodium_potassium_pump_current)
_(   K_mk , 1.0 , 1 )   // millimolar (in sodium_potassium_pump_current)
_(   P_NaK , 2.724 , 1 )   // picoA_per_picoF (in sodium_potassium_pump_current)
_(   g_to , 0.294 , 1 )   // nanoS_per_picoF (in transient_outward_current)
